/*
** 1998-09-12 -	This module contains code to allow the user to select a style from a
**		simple list representation. This is used in two places; the "reparent"
**		button in cfg_styles, and the "style" button in cfg_types. Since the
**		old (short, inline) approach was severely broken, this needs a module
**		of its own.
** 1999-05-24 -	More or less completely rewritten. About 1/4 the size of the old one.
** 1999-06-19 -	Adapted for the new dialog module.
*/

#include "gentoo.h"

#include <stdlib.h>

#include "styles.h"
#include "dialog.h"
#include "style_dialog.h"

/* ----------------------------------------------------------------------------------------- */

static void evt_cursor_changed(GtkWidget *wid, gpointer user)
{
	GtkTreePath	*path = NULL;
	GtkTreeIter	iter;

	gtk_tree_view_get_cursor(GTK_TREE_VIEW(wid), &path, NULL);
	gtk_tree_model_get_iter(GTK_TREE_MODEL(gtk_tree_view_get_model(GTK_TREE_VIEW(wid))), &iter, path);
	gtk_tree_model_get(GTK_TREE_MODEL(gtk_tree_view_get_model(GTK_TREE_VIEW(wid))), &iter, 1, user, -1);
}

/* 1999-05-24 -	Main style dialog entry point. */
Style * sdl_dialog_sync_new_wait(StyleInfo *si, Style *ignore)
{
	GtkWidget	*scwin, *tv;
	Style		*sel = NULL;
	Dialog		*dlg;
	GtkCellRenderer	*cr;
	GtkTreeViewColumn *vc;

	scwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scwin), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

	tv = gtk_tree_view_new_with_model(GTK_TREE_MODEL(stl_styleinfo_build_partial2(si, ignore)));
	cr = gtk_cell_renderer_text_new();
	vc = gtk_tree_view_column_new_with_attributes("(Styles)", cr, "text", 0, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(tv), vc);
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(tv), FALSE);
	g_signal_connect(G_OBJECT(tv), "cursor_changed", G_CALLBACK(evt_cursor_changed), &sel);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scwin), tv);
	
	gtk_widget_set_usize(scwin, 256, 448);
	dlg = dlg_dialog_sync_new(scwin, _("Select Style"), NULL);
	if(dlg_dialog_sync_wait(dlg) != DLG_POSITIVE)
		sel = NULL;
	dlg_dialog_sync_destroy(dlg);

	return sel;
}
